// Beispiel: Der String "Hello World" in Stack, Heap und Read-Only-Speicher
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char global_array[] = "Hello World";

int main()
{
	char local_array[] = "Hello World";
	char *literal_pointer = "Hello World";
	char *heap_pointer = strdup("Hello World");
	
	printf("global_array:\n\t%s %p\n", global_array, global_array);
	printf("local_array:\n\t%s %p\n", local_array, local_array);
	printf("literal_pointer:\n\t%s %p\n", literal_pointer, literal_pointer);
	printf("\"Hello World\":\n\t%s %p\n", "Hello World", "Hello World");
	printf("heap_pointer:\n\t%s %p\n", heap_pointer, heap_pointer);
	
	free(heap_pointer);
	return 0;
}